
(function($){
	
	'use strict';
	
	wp.mce = wp.mce || {};
	
	function rgb2hex(e) {
		if (e.search("rgb") == -1) {
			return e
		} else {
			e = e.match(/^rgba?\((\d+),\s*(\d+),\s*(\d+)(?:,\s*(\d+))?\)$/);

			function t(e) {
				return ("0" + parseInt(e).toString(16)).slice(-2)
			}
			return "#" + t(e[1]) + t(e[2]) + t(e[3])
		}
	}
	
	
	
	
	var popup_templates = {};
	popup_templates.button = {
		
		//title: '#fasc-popup-edit-button',		
		content_id: 'fasc-popup-edit-button',
		is_editing: false,
		$node: {},
		//tabs,
		
		init: function(node, $popup, is_editing, text_selection){
			
			this.$popup = $popup;
			this.$preview_area = $popup.find(".preview-button-area .centered-button");
			this.is_editing = is_editing;
			this.$node = jQuery(node);

			this.setupControls($popup);
			this.setupIcons(node, $popup);
			this.setupTabs($popup);
			
			if(this.is_editing)
			{
				this.setSettingsFromNode(node, $popup, true);
			}
			else
			{
				this.initEmptyTemplate(node, $popup, text_selection);
			}
			
			this.updatePreview();
			
		},
		setupIcons: function(node, $popup){
			
			var self = this;
			var $node = $(node);
			
			var $tab2content = $popup.find('.fasc-ajax-content .fasc-tab-content[data-fasc-tab="2"]');
			
			$tab2content.find('#fasc-popup-icon-type-select').change(function(t) {
				
				var $val = $(this).val();
				
				$tab2content.find('.ico-grid .grid-container').removeClass("ico-screen-active").hide();
				$tab2content.find('#' + $(this).val()).addClass("ico-screen-active").show();
			});
			$tab2content.find('.ico-grid div').click(function(t) {
				t.preventDefault();
				$tab2content.find('.ico-grid div').removeClass("active");
				$(this).addClass("active");
				self.updatePreview();
				$tab2content.find('.fasc-ico-position').removeAttr("checked");
				$tab2content.find('.fasc-ico-position[value="before"]').prop("checked", true);
				
				return false
			});
			$tab2content.find('.fasc-ico-position').change(function(t) {
				
				if ($(this).val() == "none") {
					$tab2content.find('.ico-grid div div:not(.clear)').removeClass("active")
				} else if ($(this).val() == "before") {
					var $active = $tab2content.find('.ico-grid div.active');
					if ($active.length == 1) {} else {
						$($tab2content.find('.ico-grid div.ico-screen-active div:not(.clear)').get(0)).addClass("active")
					}
				}
				self.updatePreview();
			});
		   
			$('.fasc-ajax-content select, .fasc-ajax-content input[type="checkbox"]').change(function() {
				self.updatePreview();
			});
			$('.fasc-ajax-content input[type="text"]').keyup(function() {
				self.updatePreview();
			});
			$('.fasc-ajax-content input[type="text"]').keyup(function() {
				self.updatePreview();
			});
			
			self.updatePreview();
			
			$.get(Fasc.ajax_url + "?action=fasc_buttons&load=get_buttons", function(e) {
				self.parseTemplateButtons(e)
			}, "json");
			$(".fasc-save-btn").click(function() {
				var save_data = {};
				save_data.button = self.createButtonHtml({
					isSaving: true
				});
				
				$.post(Fasc.ajax_url + "?action=fasc_buttons&load=save_button", save_data, function(e) {
					self.parseTemplateButtons(e);
				}, "json");
				
				self.$tabs.find("li").removeClass("active");
				self.$tabs.find("li[data-fasc-tab='3']").addClass("active");
				/*$("#tab-header li").removeClass("active");
				$('#tab-header li a[href="#tab-3-content"]').parent().addClass("active");*/
				self.loadTab(3, $popup);
				return false
			});
			
		},
		
		parseTemplateButtons: function(e) {
			var self = this;
			var t = $(".saved-buttons-tab .container-grid ul");
			t.empty();
			var n = "";
			var r = 0;
			$.each(e, function(i) {
				n = "";
				var s = $(e[i]["html"]);
				var o = s.css("background-color");
				var u = s.css("color");
				n += "<li data-index='" + r + "'>";
				n += '<div class="wrap">';
				n += '<div class="full_button">' + e[i]["html"] + "</div>";
				n += '<div class="name"><span>' + e[i]["name"] + '</span> <a class="dashicons dashicons-edit fasc-button-edit"></a><a class="fa fa-check fasc-button-update" data-action="update"></a><a class="dashicons dashicons-no-alt fasc-button-update" data-action="remove"></a></div>';
				n += '<div class="col fasc-button-remove dashicons dashicons-no-alt"></div>';
				n += '<div class="col" style="background-color:' + o + ';"></div>';
				n += '<div class="col" style="background-color:' + u + ';"></div>';
				n += '<div class="clear"></div>';
				n += "</div>";
				n += "</li>";
				t.append(n);
				r++
			});
			var i = function(e) {
				var t = e.text();
				var n = $("<input>", {
					val: t,
					type: "text",
					width: "170px",
					"data-orig-text": t
				});
				e.replaceWith(n);
				n.select()
			};
			var s = function(e) {
				var t = $("<span>", {
					text: e.attr("data-orig-text")
				});
				e.replaceWith(t);
				t.on("click", i)
			};
			var o = function(e) {
				var t = $("<span>", {
					text: e.val()
				});
				e.replaceWith(t);
				t.on("click", i)
			};
			$(".fasc-button-edit").click(function() {
				$(this).hide();
				$(this).parent().find(".fasc-button-update").show().css("display", "inline-block");
				i($(this).parent().find("span"));
				return false
			});
			$(".fasc-button-remove").click(function(e) {
				e.preventDefault();
				var t = $(this).closest("li").attr("data-index");
				$.get(Fasc.ajax_url + "?action=fasc_buttons&load=remove_button&index=" + t, function(e) {
					self.parseTemplateButtons(e)
				}, "json");
				return false
			});
			$(".fasc-button-update").click(function() {
				var e = $(this);
				$(this).parent().find(".fasc-button-update").hide();
				$(this).parent().find(".fasc-button-edit").show();
				if (e.attr("data-action") == "remove") {
					s($(this).parent().find("input"))
				} else {
					var t = $(this).closest("li").attr("data-index");
					var n = encodeURIComponent($(this).parent().find("input").val());
					$.get(Fasc.ajax_url + "?action=fasc_buttons&load=update_button&index=" + t + "&name=" + n, function(e) {
						self.parseTemplateButtons(e)
					}, "json");
					o($(this).parent().find("input"))
				}
				return false
			});
			var $template_options = $(".saved-buttons-tab .container-grid li .wrap");
			$template_options.on("click", function() {
				$template_options.removeClass("active");
				$(this).addClass("active");
				var $saved_button = $(this).find(".full_button a.fasc-button");
				self.loadButtonTemplate($saved_button, true);
				self.updatePreview();
			})
		},

		loadButtonTemplate: function ($saved_button, t) {
			var self = this;
			
			/*var r = $saved_button.attr("href");
			if (typeof t == "undefined") {
				jQuery(".fasc-ajax-content input#button-url").val(r)
			}*/
			var button_target = $saved_button.attr("target");
			
			jQuery(".fasc-ajax-content input#fasc-popup-new-window").prop("checked", false);
			if (typeof button_target != "undefined") {
				if (button_target == "_blank") {
					jQuery(".fasc-ajax-content input#fasc-popup-new-window").prop("checked", true)
				}
				
			}
			
			var rel = $saved_button.attr("rel");
			jQuery(".fasc-ajax-content input#fasc-popup-nofollow").prop("checked", false);
			if (typeof rel != "undefined") {
				if (rel == "nofollow") {
					jQuery(".fasc-ajax-content input#fasc-popup-nofollow").prop("checked", true)
				}
				
			}
			
			if (typeof t == "undefined") {
				var s = $saved_button.text();
				jQuery(".fasc-ajax-content input#fasc-popup-button-text").val(s)
			}
			
			var o = rgb2hex($saved_button.css("color"));
			jQuery("#fasc-popup-text-color").val(o);
			self.refreshMiniColors(jQuery("#fasc-popup-text-color"), o, self.$popup);
			
			var u = rgb2hex($saved_button.css("background-color"));
			jQuery("#fasc-popup-button-color").val(u);
			self.refreshMiniColors(jQuery("#fasc-popup-button-color"), u, self.$popup);
			
			
			var $tab2content = self.$popup.find('.fasc-ajax-content .fasc-tab-content[data-fasc-tab="2"]');
			
			
			$tab2content.find(".ico-grid > div > div").removeClass("active"); /*  *** */
			
			var classes = $saved_button.attr("class").split(/\s+/);
			
			self.$popup.find(".fasc-mce-button[data-fasc-action='bold']").attr("data-fasc-button-active", "0");
			self.$popup.find(".fasc-mce-button[data-fasc-action='italic']").attr("data-fasc-button-active", "0");
			self.$popup.find(".fasc-mce-button[data-fasc-action='strikethrough']").attr("data-fasc-button-active", "0");
			
			for (var f = 0; f < classes.length; f++) {
				if (classes[f].substring(0, 9) == "fasc-type") {
					var l = classes[f];
					if ($saved_button.hasClass("fasc-rounded-medium") || $saved_button.hasClass("rounded")) {
						l = l + " " + "fasc-rounded-medium"
					}
					jQuery("#fasc-popup-button-type option").removeAttr("selected");
					jQuery('#fasc-popup-button-type option[value="' + l + '"]').attr("selected", "selected");
					$("#fasc-popup-button-type").val(l)
				}
				 else if (classes[f].substring(0, 10) == "fasc-style") {
					
					if(classes[f]=="fasc-style-bold")
					{
						self.$popup.find(".fasc-mce-button[data-fasc-action='bold']").attr("data-fasc-button-active", "1");
					}
					else if(classes[f]=="fasc-style-italic")
					{
						self.$popup.find(".fasc-mce-button[data-fasc-action='italic']").attr("data-fasc-button-active", "1");
					}
					else if(classes[f]=="fasc-style-strikethrough")
					{
						self.$popup.find(".fasc-mce-button[data-fasc-action='strikethrough']").attr("data-fasc-button-active", "1");
					}
				
				}
				else if (classes[f].substring(0, 9) == "fasc-size") {
					var c = classes[f];
					jQuery("#fasc-popup-button-size option").removeAttr("selected");
					jQuery('#fasc-popup-button-size option[value="' + c + '"]').attr("selected", "selected");
					$("#button-size").val(c)
				}  else if (classes[f].substring(0, 9) == "dashicons") {
					$tab2content.find(".ico-grid .grid-container").removeClass("ico-screen-active");
					$tab2content.find("#dashicons-grid").addClass("ico-screen-active");
					self.$popup.find("#fasc-popup-icon-type-select").val("dashicons-grid");
					self.$popup.find("#fasc-popup-icon-type-select").trigger("change");
					var h = classes[f];
					self.$popup.find(".ico-grid ." + h).addClass("active");
					$tab2content.find('.fasc-ico-position[value="before"]').attr("checked", "checked")
				} else if (classes[f].substring(0, 3) == "fa-") {
					$tab2content.find(".ico-grid .grid-container").removeClass("ico-screen-active");
					var $button = $tab2content.find(".ico-grid").find("." + classes[f]);
					
					var p = $button.parent().attr("id");
					
					var d = $tab2content.find("#" + p);
					d.addClass("ico-screen-active");
					self.$popup.find("#fasc-popup-icon-type-select").val(p);
					self.$popup.find("#fasc-popup-icon-type-select").trigger("change");
					self.$popup.find(".ico-grid ." + classes[f]).addClass("active");
					$tab2content.find('.fasc-ico-position[value="before"]').attr("checked", "checked")
				}
			}
			if($saved_button.hasClass(""))
			{
				
			}
			
		},

		setupControls: function($popup){
			
			var self = this;
			
			$popup.find('.fasc-ajax-content select, .fasc-ajax-content input[type="checkbox"]').change(function() {
				self.updatePreview();
			});
			
			$popup.find('.fasc-ajax-content input[type="text"]').keyup(function() {
				self.updatePreview();
			});
			
			$popup.find('.fasc-ajax-content input[type="text"]').keyup(function() {
				self.updatePreview();
			});
			
			
			var $colour_picker_buttons = $popup.find("[data-fasc-action='popup-colorpicker']");
			$colour_picker_buttons.click(function(e){
				
				var $button = $(this);
				var is_already_active = $button.attr("data-fasc-button-active");
				
				//remove the active state from other buttons
				$colour_picker_buttons.attr("data-fasc-button-active", "");
				
				var button_active = 1 - is_already_active;
				$button.attr("data-fasc-button-active", button_active);
				
				var popup_name = $button.data("fasc-action-target");
				var $colour_popup = $popup.find('[data-fasc-colorpicker-name="'+popup_name+'"]');
				var $other_popups = $popup.find('[data-fasc-colorpicker-name]').not('[data-fasc-colorpicker-name="'+popup_name+'"]');
				var button_position = $button.position();
				
				//$other_popups.fadeOut(100);
				$other_popups.stop(true,true).hide();
				$colour_popup.stop(true,true).fadeToggle(100);
				$colour_popup.css("left", Math.round(button_position.left)+"px");
				$colour_popup.css("top", Math.round(button_position.top+$button.parent().outerHeight())+"px");
				
			});
			
			$popup.on('click', function(event) {
				
				//hide toolbar popups (like colour picker) only if we are not interacting with them directly
				var $closest = $(event.target).closest("[data-fasc-action='popup-colorpicker'], .fasc-popup-colorpicker-container");
				if($closest.length==0)
				{
					$popup.find('[data-fasc-colorpicker-name]').hide();
					$colour_picker_buttons.attr("data-fasc-button-active", "");
				}
			});
			
			var $toggle_buttons = $popup.find(".fasc-mce-button-toggle");
			$toggle_buttons.on("click", function(){
				
				var $button = $(this);
				var is_already_active = $button.attr("data-fasc-button-active");
				var button_active = 1 - is_already_active;
				$button.attr("data-fasc-button-active", button_active);
				
				self.updatePreview();
			});
			
			/*var $toolbar_buttons = $popup.find(".fasc-mce-button");
			$toolbar_buttons.on("click", function(){
				
				var $button = $(this);
				var action =  = $button.data("fasc-action");
				
				if(action=="bold")
				{
					
				}
				
			});*/
			
			self.updatePreview();
			
		},
		updatePreview: function (){
			
			this.$preview_area.html(this.createButtonHtml());
			this.$preview_area.find(".fasc-button").click(function(e){
				
				e.preventDefault();
				e.stopPropagation();
				
			});
			
		},
		createButtonHtml: function(settings) {
			
			var defaults = {
				content: "",
				isSaving: false,
				hasID: false
			};
			$.extend(defaults, settings);
			var n = jQuery(".fasc-ajax-content input#fasc-popup-button-url").val();
			var r = jQuery(".fasc-ajax-content input#fasc-popup-button-text").val();
			var i = jQuery(".fasc-ajax-content select#fasc-popup-button-size").val();
			var s = jQuery(".fasc-ajax-content input#fasc-popup-button-color").val();
			var o = jQuery(".fasc-ajax-content input#fasc-popup-text-color").val();
			var u = jQuery(".fasc-ajax-content select#fasc-popup-button-type").val();
			var a = jQuery(".fasc-ajax-content select#fasc-popup-button-align").val();
			var f = jQuery(".fasc-ajax-content input#fasc-popup-new-window").prop("checked");
			var ff = jQuery(".fasc-ajax-content input#fasc-popup-nofollow").prop("checked");
			var l = "";
			var c = "";
			var h = "";
			var p = "";
			var d = "";
			var v = "";
			var vv = "";
			var m = "";
			if (f == true) {
				v = ' target="_blank"'
			}
			if (ff == true) {
				vv = ' rel="nofollow"'
			}
			if (u) {
				if (u != "") {
					h = " " + u
				}
			}
			if (i) {
				if (i != "") {
					p = " " + i
				}
			}
			
			
			var $active_icon = $($('.fasc-ajax-content .fasc-tab-content[data-fasc-tab="2"] .ico-grid div.active').get(0));
			
			//var $active_icon = $($("#tab-2-content .ico-grid div.active").get(0));
			var y = "";
			var b = "";
			
			
			if ($active_icon.length == 1) {
				
				
				var icon_classes = $active_icon.attr("class").split(" ");
				var E = 0;
				var S = "dashicons";
				for (E = 0; E < icon_classes.length; E++) {
					if (icon_classes[E] != "active" && icon_classes[E] != "fa" && icon_classes[E] != "dashicons") {
						y += " " + icon_classes[E]
					}
					if (icon_classes[E] == "fa") {
						S = "fontawesome"
					}
				}
				if (E > 0) {
					if (S == "fontawesome") {
						y = " ico-fa fasc-ico-before" + y
					} else {
						y = " fasc-ico-before" + y
					}
				}
			}
			
			
			var add_classes = "";
			
			//check bold
			var bold = this.$popup.find(".fasc-mce-button[data-fasc-action='bold']").attr("data-fasc-button-active");
			if(bold==1)
			{
				add_classes += " fasc-style-bold";
			}
			//check italic
			var italic = this.$popup.find(".fasc-mce-button[data-fasc-action='italic']").attr("data-fasc-button-active");
			if(italic==1)
			{
				add_classes += " fasc-style-italic";
			}
			//check strikethrough
			var strikethrough = this.$popup.find(".fasc-mce-button[data-fasc-action='strikethrough']").attr("data-fasc-button-active");
			if(strikethrough==1)
			{
				add_classes += " fasc-style-strikethrough";
			}
			
			//alignment
			var alignment = this.$popup.find(".fasc-mce-button[data-fasc-action='strikethrough']").attr("data-fasc-button-active");
			if(strikethrough==1)
			{
				add_classes += " fasc-style-strikethrough";
			}
			
			var id_str = '';
			if(defaults.hasID)
			{
				var button_id = new Date().getTime();
				id_str = ' data-fasc-id="fasc-button-tid-'+button_id+'"';
				
				//add_classes += " fasc-button-tid-"+button_id;
			}
			
			var x = "";
			if (!defaults.isSaving) {
				x = '<a data-fasc-href="' + n + '" class="fasc-button' + p + h + y + add_classes + '"' + v + vv + ' style="background-color:' + s + ";color:" + o + ';" data-fasc-style="background-color:' + s + ";color:" + o + ';"'+id_str+'>' + r + "</a>";
			} else {
				x = '<a class="fasc-button' + p + h + y + add_classes + '"' + v + vv + ' style="background-color:' + s + ";color:" + o + ';" data-fasc-style="background-color:' + s + ";color:" + o + ';"'+id_str+'></a>';
			}
			
			if(defaults.isSaving)
			{
				
			}
			
			return x
		},
		
		setupTabs: function($popup){
			
			var self = this;
			
			this.$tabs = $popup.find('.tab-header');
			
			var $tab_li = this.$tabs.find("li");
			var $tab_links = this.$tabs.find("li a");
			
			$tab_li.click(function() {
				
				var $self = $(this);
				var tab_number = $self.attr("data-fasc-tab");
				
				$tab_li.removeClass("active");
				$self.addClass("active");
				
				self.loadTab(tab_number, $popup);
				return false
			});
		},
		loadTab: function(tab_number, $popup){
		
			
			$popup.find(".fasc-ajax-content .fasc-tab-content").hide();
			$popup.find(".fasc-ajax-content .fasc-tab-content[data-fasc-tab="+tab_number+"]").show();
			
			this.loadTabContent(tab_number);
			
			if ($(".ico-grid .grid-container div.active").length > 0) {
				
				$(".ico-grid").scrollTop($(".ico-grid .grid-container div.active").position().top - 5)
			}
		},
		loadTabContent: function(tab_number, $popup){
			
		}, 
		refreshMiniColors: function(e, t, $popup) {
			
			var self = this;
			var n = jQuery(".preview-button-area .centered-button");
			
			/*e.wpColorPicker({
				
				change: function(event, ui)
				{
					self.updatePreview();
				},
				palettes: false,
				mode: 'hsl',
				width: 215
				
			});
			*/
			e.is_text_input = false;
			e.minicolors({
				//position: "top right",
				inline: true,
				opacity: false,
				showSpeed: 0,
				hideSpeed: 0,
				textfield: true,
				change: function(et, t) {
					var color = e.val();
					
					var $colortext = e.parent().parent().find(".fasc-popup-color-input");
					
					if(e.is_text_input == true)
					{
						e.is_text_input = false;
					}
					else
					{
						$colortext.val(color);
					}
					
					$colortext.off("input");
					$colortext.on("input", function(){
						var inputval = $(this).val();
						
						e.is_text_input = true;
						e.minicolors('value', inputval);
					});
					
					
					//var fgcolortext = $('#fasc-popup-text-color').closest(".fasc-popup-button-color-input").val();
					var bgcolor = $('#fasc-popup-button-color').val();
					var fgcolor = $('#fasc-popup-text-color').val();
					
					$popup.find(".fasc-ico-fg .fg-panel").css("background-color", fgcolor);
					$popup.find(".fasc-ico-bg .bg-panel").css("background-color", bgcolor);
					
					self.updatePreview();
				}
			});
			if (typeof t != "undefined") {
				e.minicolors("value", t)
			}
		},
		initEmptyTemplate: function(node, $popup, text_selection) {
			
			//if(!this.is_editing)
			//{
				//jQuery("#fasc-popup-button-text").val(this.$node.text())
			//}
			
			jQuery("#fasc-popup-button-text").val(text_selection);
			
			var $init_button = $popup.find(".preview-button-area .centered-button .fasc-button");
			
			this.refreshMiniColors($popup.find("#fasc-popup-text-color"), rgb2hex($init_button.css("color")), $popup);
			this.refreshMiniColors($popup.find("#fasc-popup-button-color"),  rgb2hex($init_button.css("background-color")), $popup);
			
			//jQuery("#fasc-popup-button-text").val(this.$node.text());
			
		},
		setSettingsFromNode: function(node, $popup, t) {
			
			var $node = $(node);
			
			var n = "";
			//var href = $node.attr("href");
			var href = $node.attr("data-fasc-href");
			//if (typeof t == "undefined") {
				$popup.find(".fasc-ajax-content input#fasc-popup-button-url").val(href)
			//}
			var i = $node.attr("target");
			$popup.find(".fasc-ajax-content input#fasc-popup-new-window").prop("checked", false);
			if (typeof i != "undefined") {
				if (i == "_blank") {
					$popup.find(".fasc-ajax-content input#fasc-popup-new-window").prop("checked", true)
				}
			}
			
			var rel = $node.attr("rel");
			$popup.find(".fasc-ajax-content input#fasc-popup-nofollow").prop("checked", false);
			if (typeof rel != "undefined") {
				if (rel == "nofollow") {
					$popup.find(".fasc-ajax-content input#fasc-popup-nofollow").prop("checked", true)
				}
			}
			
			
			//if (typeof t == "undefined") {
				var input_text = $node.text();
				$popup.find(".fasc-ajax-content input#fasc-popup-button-text").val(input_text)
			//}
			
			var o = rgb2hex($node.css("color"));
			$popup.find("#fasc-popup-text-color").val(o);
			$popup.find(".fasc-ico-fg .fg-panel").css("background-color", o);
			this.refreshMiniColors($popup.find("#fasc-popup-text-color"), o, $popup);
			
			var u = rgb2hex($node.css("background-color"));
			$popup.find("#fasc-popup-button-color").val(u);
			$popup.find(".fasc-ico-bg .bg-panel").css("background-color", u);
			this.refreshMiniColors($popup.find("#fasc-popup-button-color"), u, $popup);
			
			var $tab2content = $popup.find('.fasc-ajax-content .fasc-tab-content[data-fasc-tab="2"]');
			
			var classes = $node.attr("class").split(/\s+/);
			$tab2content.find(".ico-grid > div > div").removeClass("active"); /*  *** */
			for (var f = 0; f < classes.length; f++) {
				
				
				if (classes[f].substring(0, 9) == "fasc-type") {
					var l = classes[f];
					if ($node.hasClass("fasc-rounded-medium") || $node.hasClass("rounded")) {
						l = l + " " + "fasc-rounded-medium"
					}
					$popup.find("#fasc-popup-button-type option").removeAttr("selected");
					$popup.find('#fasc-popup-button-type option[value="' + l + '"]').attr("selected", "selected");
					$popup.find("#fasc-popup-button-type").val(l)
				} else if (classes[f].substring(0, 10) == "fasc-style") {
					
					if(classes[f]=="fasc-style-bold")
					{
						$popup.find(".fasc-mce-button[data-fasc-action='bold']").attr("data-fasc-button-active", "1");
					}
					else if(classes[f]=="fasc-style-italic")
					{
						$popup.find(".fasc-mce-button[data-fasc-action='italic']").attr("data-fasc-button-active", "1");
					}
					else if(classes[f]=="fasc-style-strikethrough")
					{
						$popup.find(".fasc-mce-button[data-fasc-action='strikethrough']").attr("data-fasc-button-active", "1");
					}
				
				} else if (classes[f].substring(0, 9) == "fasc-size") {
					var c = classes[f];
					$popup.find("#fasc-popup-button-size option").removeAttr("selected");
					$popup.find('#fasc-popup-button-size option[value="' + c + '"]').attr("selected", "selected");
					$popup.find("#fasc-popup-button-size").val(c)
				} else if (classes[f].substring(0, 9) == "dashicons") {
					$tab2content.find(".ico-grid .grid-container").removeClass("ico-screen-active");
					$tab2content.find("#dashicons-grid").addClass("ico-screen-active");
					$popup.find("#fasc-popup-icon-type-select").val("dashicons-grid");
					$popup.find("#fasc-popup-icon-type-select").trigger("change");
					var h = classes[f];
					$popup.find(".ico-grid ." + h).addClass("active");
					$tab2content.find('.fasc-ico-position[value="before"]').attr("checked", "checked")
				} else if (classes[f].substring(0, 3) == "fa-") {
					$tab2content.find(".ico-grid .grid-container").removeClass("ico-screen-active");
					var $button = $tab2content.find(".ico-grid").find("." + classes[f]);
					
					var p = $button.parent().attr("id");
					
					var d = $tab2content.find("#" + p);
					d.addClass("ico-screen-active");
					$popup.find("#fasc-popup-icon-type-select").val(p);
					$popup.find("#fasc-popup-icon-type-select").trigger("change");
					$popup.find(".ico-grid ." + classes[f]).addClass("active");
					$tab2content.find('.fasc-ico-position[value="before"]').attr("checked", "checked")
				}
			}
			
		}
	};
	
	wp.mce.fascpopup = {
		
		open: function(object, type, callback, is_editing, text_selection)
		{
			
			//callback('<a class="fasc-button fasc-size-xlarge fasc-type-glossy fasc-rounded-medium fasc-ico-before dashicons-welcome-add-page" style="background-color: #bd3535; color: #ffffff;" href="">sdsdfsdfsdf sf sdsdvxcvxccvvxcxvf </a>');
			//return;
			this.type = type;
			this.templateID = type;
			this.is_editing = is_editing;
			
			var content_ID = popup_templates[type].content_id;
			
			var $overlay = jQuery('<div/>', {
				'class': 'fasc-thickbox-overlay',
			}).appendTo('body');
			
			//init the variuos controls
			
			var $popup = $('#fasc-popup-template').clone();
			$popup.removeAttr("id"); //we don't want duplicate IDs in the page
			$popup.addClass(content_ID);
			
			var $content_template = $("#"+content_ID);
			var $content_template_copy = $content_template.clone();
			$content_template.remove(); //remove the original so there are no duplicate IDs - make sure to re-append to the body once popup closes
			
			var $popup_content = $popup.find('.fasc-thickbox-content');
			
			var $title_inner = $popup.find(".fasc-thickbox-title-inner");
			var $submit_button = $popup.find(".fasc-thickbox-action-right");
			
			//pass data and setup the tempalte
			this.initTemplate($popup, $content_template_copy, $popup_content, $title_inner, $submit_button);
			
			
			
			/* when popup is ready/initialised, then show it */
			$popup.insertAfter($overlay);
						
			popup_templates[type].init(object, $popup, this.is_editing, text_selection); //run js/init if UI
			
			$popup.show();
			
			this.initEvents(object, $popup, $submit_button, $popup_content, $content_template_copy, callback);
						
		},
		
		initTemplate: function($popup, $content_template, $popup_content, $title_inner, $submit_button)
		{
			$popup_content.html($content_template.html());
			
			var title = $content_template.attr("data-fasc-title");
			var submit_label = $content_template.attr("data-fasc-submit-label");
			
			var width = $content_template.attr("data-fasc-width");
			var height = $content_template.attr("data-fasc-height");
			
			$title_inner.text(title);
			$submit_button.text(submit_label);
			
			//$popup.width(width);
			$popup.css("max-width", width);
			//$popup.height(height);
			$popup.css("max-height", height);
						
		},
		initEvents: function(object, $popup, $submit_button, $popup_content, $content_template, callback)
		{
			var self = this;
			
			$popup.find('label').click(function(){
				
				
			});
					
					
			var $close_button = $popup.find(".fasc-close-ajax-window");
						
			$close_button.click(function()
			{
				self.removePopup($popup, $content_template);
				
			});
			
			$('.fasc-thickbox-overlay').on('click', function(event) {
				self.removePopup($popup, $content_template);
			});
			
			
			$submit_button.click(function(e)
			{
				e.preventDefault();
				e.stopImmediatePropagation();
				
				var button_html = popup_templates[self.type].createButtonHtml({
					isSaving: false,
					hasID: true
				});
				
				var button_id = jQuery(button_html).attr("data-fasc-id");
				callback(button_html, button_id);
				self.removePopup($popup, $content_template);
				
				return false;
			});
			
			
			
			
			var width = $content_template.attr("data-fasc-width");
			var height = $content_template.attr("data-fasc-height");
			
			//now position it correctly
			$(window).resize(_.debounce(function(){
				self.centerPopup($popup);
			}, 100));
			self.centerPopup($popup, width, height);
			
			
			
		},
		
		removePopup: function($popup, $content_template)
		{
			var self = this;
			
			$('.fasc-thickbox-overlay').remove();
			$popup.remove();
			$('body').append($content_template);
			$content_template.attr("id", popup_templates[self.type].content_id);
			
		},
		
		centerPopup: function($popup, width, height)
		{
			var $popup_header = $popup.find(".fasc-thickbox-header");
			var $popup_footer = $popup.find(".fasc-thickbox-footer");
			var $popup_content = $popup.find(".fasc-thickbox-content");
			
			var container = $(window);
			var top = -$popup.height() / 2;
			var left = -$popup.width() / 2;
			
			$popup.css('position', 'fixed').css({ 'margin-left': left + 'px', 'margin-top': top + 'px', 'left': '50%', 'top': '50%' });
			
			//hide content so it doesn't affect height/width calculation
			$popup_content.hide();
			
			//now we have centered the object - check to see if box has been shrunk below the passed in height variable
			var outer_height = $popup.outerHeight();
			
			var remaining_height = outer_height;
			
			remaining_height -= $popup_header.outerHeight();
			remaining_height -= $popup_footer.outerHeight();
			
			$popup_content.height(remaining_height);
			$popup_content.show();
			
			
			/*if( outer_height < height)
			{
				
			}*/
			
			
		}
		
	}
	
}(jQuery));
