/* global tinymce */

/**
 * WordPress View plugin.
 */
(function() {
	tinymce.PluginManager.add( 'fascview', function( editor ) {
		
		var $ = editor.$,
			selected,
			Env = tinymce.Env,
			VK = tinymce.util.VK,
			TreeWalker = tinymce.dom.TreeWalker,
			toRemove = false,
			firstFocus = true,
			_noop = function() { return false; },
			isios = /iPad|iPod|iPhone/.test( navigator.userAgent ),
			cursorInterval,
			lastKeyDownNode,
			focus,
			execCommandView,
			execCommandBefore,
			toolbar;
		
		
		/**
		 * Returns the node or a parent of the node that has the passed className.
		 * Doing this directly is about 40% faster
		 */
		/*function getParent( node, className ) {
			while ( node && node.parentNode ) {
				if ( node.className && ( ' ' + node.className + ' ' ).indexOf( ' ' + className + ' ' ) !== -1 ) {
					return node;
				}

				node = node.parentNode;
			}

			return false;
		}*/
		
		
		
		function _stop( event ) {
			event.stopPropagation();
		}		
		
		// Check if the `wp.mce` API exists.
		if ( typeof wp === 'undefined' || ! wp.mce ) {
			return {
				getView: _noop
			};
		}
				
		// When the editor's content has been updated and the DOM has been
		// processed, render the views in the document.
		editor.on( 'SetContent', function() {
			
			addFascInlineHtml();
			
		});
		/*editor.undoManager.onAdd.add(function(){
			
				alert("TO");
		});*/
		
		
		editor.on( 'init', function() {
			
			editor.on("dblClick", function(event) {
				
				if(editor.dom.hasClass(event.target, "fasc-button"))
				{
					event.preventDefault();
					//selected = event.target;
					popupwindow( editor, event.target, true );
					
					return false;
				}
				
			}, true);
			
			editor.addCommand( 'popup_insert_fasc_button', function(value1, value2) {
				//console.log(editor.selection.getNode());
				
				var is_editing = false;
				
				if(editor.dom.hasClass(editor.selection.getNode(), "fasc-button"))
				{
					is_editing = true;
				}
				var text_selection = editor.selection.getContent({format : 'text'});
				
				alert("HERE: "+text_selection);
				popupwindow( editor, editor.selection.getNode(), is_editing, {}, text_selection );
			});
			
			var scrolled = false,
				selection = editor.selection,
				MutationObserver = window.MutationObserver || window.WebKitMutationObserver;
			
		
			editor.undoManager.onAdd.add(function(ed){
			
				//console.log("ON ADD TO UNDO");
				//console.log(ed);
			});
			
			
			// When a view is selected, ensure content that is being pasted
			// or inserted is added to a text node (instead of the view).
			/*editor.on( 'BeforeSetContent', function() {
				var walker, target,
					view = getView( selection.getNode() );

				// If the selection is not within a view, bail.
				if ( ! view ) {
					return;
				}

				if ( ! view.nextSibling || getView( view.nextSibling ) ) {
					// If there are no additional nodes or the next node is a
					// view, create a text node after the current view.
					target = editor.getDoc().createTextNode('');
					editor.dom.insertAfter( target, view );
				} else {
					// Otherwise, find the next text node.
					walker = new TreeWalker( view.nextSibling, view.nextSibling );
					target = walker.next();
				}

				// Select the `target` text node.
				selection.select( target );
				selection.collapse( true );
			});*/

			editor.dom.bind( editor.getDoc(), 'touchmove', function() {
				scrolled = true;
			});

			editor.on( 'mousedown mouseup click touchend', function( event ) {
				
				firstFocus = false;
				
				if(editor.dom.hasClass(event.target, "fasc-button"))
				{
					//event.stopImmediatePropagation();
				//	event.preventDefault();
					
					
					if ( event.type === 'touchend' && scrolled ) {
						scrolled = false;
					} else {
						selectFascButton(event.target);
					}
					
					// Returning false stops the ugly bars from appearing in IE11 and stops the view being selected as a range in FF.
					// Unfortunately, it also inhibits the dragging of views to a new location.
					//return false;
				}else {
					if ( event.type === 'touchend' || event.type === 'mousedown' ) {
						deselectFascButton();
					}
				}
				
				if ( event.type === 'touchend' && scrolled ) {
					scrolled = false;
				}
			}, true );
		});
		
		// Run that before the DOM cleanup
		editor.on( 'PreProcess', function( event ) {
			//emptyViewNodes( event.node );
		}, true );

		editor.on( 'hide', function() {
			
			//removeFascInlineHtml();
			//wp.mce.fascviews.unbind();
			deselectFascButton();
			//emptyViewNodes();
		});
		
		editor.on( 'PostProcess', function( event ) {
			if ( event.content ) {
				
				/*event.content = event.content.replace( /<span [^>]*?data-fascview-text="([^"]+)"[^>]*>[\s\S]*?<\/span>/g, resetViewsCallback )
					.replace( /<span [^>]*?data-fascview-marker="([^"]+)"[^>]*>[\s\S]*?<\/span>/g, resetViewsCallback );*/
				
				event.content = removeFascInlineHtml(event.content);
				
			}
		});

		// Excludes arrow keys, delete, backspace, enter, space bar.
		// Ref: https://developer.mozilla.org/en-US/docs/Web/API/KeyboardEvent.keyCode
		function isSpecialKey( key ) {
			return ( ( key <= 47 && key !== VK.SPACEBAR && key !== VK.ENTER && key !== VK.DELETE && key !== VK.BACKSPACE && ( key < 37 || key > 40 ) ) ||
				key >= 224 || // OEM or non-printable
				( key >= 144 && key <= 150 ) || // Num Lock, Scroll Lock, OEM
				( key >= 91 && key <= 93 ) || // Windows keys
				( key >= 112 && key <= 135 ) ); // F keys
		}

		// (De)select views when arrow keys are used to navigate the content of the editor.
		editor.on( 'keydown', function( event ) {
			
			deselectFascButton();
			return;
			
		});

		/*editor.on( 'keyup', function() {
			if ( toRemove ) {
				removeView( toRemove );
				toRemove = false;
			}
		});*/

		editor.on( 'focus', function() {
			var view;

			focus = true;
			//editor.dom.addClass( editor.getBody(), 'has-focus' );

			// Edge case: show the fake caret when the editor is focused for the first time
			// and the first element is a view.
			//if ( firstFocus && ( view = getView( editor.getBody().firstChild ) ) ) {
				//setViewCursor( true, view );
			//}

			firstFocus = false;
		} );

		editor.on( 'blur', function() {
			focus = false;
			//editor.dom.removeClass( editor.getBody(), 'has-focus' );
		} );

		editor.on( 'NodeChange', function( event ) {
			var dom = editor.dom,
				views = editor.dom.select( '.fascview-wrap' ),
				className = event.element.className,
				//view = getView( event.element ),
				lKDN = lastKeyDownNode;

			lastKeyDownNode = false;

			clearInterval( cursorInterval );

		});

		editor.on( 'BeforeExecCommand', function() {
			var node = editor.selection.getNode(),
				view;
			
		});

		editor.on( 'ExecCommand', function() {
			
		});

		editor.on( 'ResolveName', function( event ) {
			
		});
		
		editor.on("PastePostProcess", function() {
			updateStyles();
		});
		function updateStyles() {
			
			/* @update */
			
			var fasc_buttons = tinymce.activeEditor.dom.select(".fasc-button");
			var remove_history_level = false;
			jQuery(fasc_buttons).each(function() {
				
				if (jQuery(this).is("[data-fasc-style]")) {
					
					var fasc_button_styles = jQuery(this).attr("data-fasc-style").replace(/\s+/, "");
					var button_styles = "";
					
					if (jQuery(this).is("[style]")) {
						
						button_styles = jQuery(this).attr("style").replace(/\s+/, "")
					}
					
					//if the styles are different then update the actual style
					if (fasc_button_styles != button_styles) {
						
						jQuery(this).attr("style", jQuery(this).attr("data-fasc-style"));
						editor.nodeChanged();
						remove_history_level = true
					}
				}
			});
			if (remove_history_level == true) {
				//editor.undoManager.removeLevel()
			}
		}
		
		editor.addButton( 'fasc_view_edit', {
			tooltip: 'Edit ', // trailing space is needed, used for context
			icon: 'dashicon dashicons-edit',
			onclick: function() {
				selected && popupwindow( editor, selected, true );
			}
		} );

		editor.addButton( 'fasc_view_remove', {
			tooltip: 'Remove',
			icon: 'dashicon dashicons-no',
			onclick: function() {
				selected && removeFascButton( selected );
			}
		} );
		
		
		
		/*function editFascButton( editor, node ) {
			var values = [];
			values['innercontent'] = "INNER CONTENT";
			popupwindow(editor, node);
		}*/
		
		function removeFascButton( node ) {
			
			//this.unbindNode.call( this, editor, node, $( node ).find( '.wpview-content' ).get( 0 ) );
			//$( node ).trigger( 'wp-mce-view-unbind' );
			
			editor.undoManager.transact( function() {
				//handleEnter( view );
				editor.dom.remove( node );
				editor.focus();
			});
			
			/*editor.undoManager.transact( function() {
				//handleEnter( view );
				wp.mce.views.remove( editor, view );
			});*/
		}
		
		editor.once( 'preinit', function() {
			
			if ( editor.wp && editor.wp._createToolbar ) {
				toolbar = editor.wp._createToolbar( [
					'fasc_view_edit',
					'fasc_view_remove'
				] );
			}
		} );

		editor.on( 'wptoolbar', function( event ) {
			if ( selected ) {
				event.element = selected;
				event.toolbar = toolbar;
			}
		} );

		// Add to editor.wp
		editor.wp = editor.wp || {};
		
		
		function selectFascButton( fasc_button ) {
			var clipboard,
				dom = editor.dom;

			if ( ! fasc_button ) {
				return;
			}
			
			//if ( fasc_button !== selected ) {
				// Make sure that the editor is focused.
				// It is possible that the editor is not focused when the mouse event fires
				// without focus, the selection will not work properly.
				editor.getBody().focus();

				deselectFascButton();
				selected = fasc_button;
				dom.setAttrib( fasc_button, 'data-mce-selected', 1 );
				

		//	}

			editor.nodeChanged();
			
		}
		
		
		function deselectFascButton( fasc_button ) {
			
			var clipboard,
				dom = editor.dom;

			if ( selected ) {
				//clipboard = editor.dom.select( '.fascview-clipboard', selected )[0];
				dom.unbind( selected, 'beforedeactivate focusin focusout click mouseup', _stop );
				dom.setAttrib( selected, 'data-mce-selected', null );
			}
			selected = null;
		}
		
		function removeFascInlineHtml( content ) {
			
			var contentObject = $(content);
			var fasc_buttons = contentObject.find( '.fasc-button' );
			fasc_buttons.attr('data-fasc-temp', null);
			fasc_buttons.attr('data-fasc-style', null);
			
			var href = fasc_buttons.attr("data-fasc-href");
			fasc_buttons.attr('href', href);
			
			//add href back to the object
			$(fasc_buttons).each(function(){
				
				var $this = $(this);
				var href = $this.attr('data-fasc-href');
				$this.attr('href', href);
				$this.attr('data-fasc-href', null);
				
			});
			
			return editor.dom.getOuterHTML(  contentObject )
		}
		
		
		function addFascInlineHtml() {
			
			//console.log("setttting content heeere");
			var fasc_buttons = editor.dom.select( '.fasc-button' );
			//var $fasc_buttons = editor.$( '.fasc-button' );
			//editor.dom.setAttrib(fasc_buttons, 'href', '' );
			
			
			for(var i=0; i<fasc_buttons.length; i++)
			{
				var fasc_button = fasc_buttons[i];
				var orig_href = editor.dom.getAttrib(fasc_button, 'href');
				var new_href = editor.dom.getAttrib(fasc_button, 'data-fasc-href');
				
				//only update if its using a regular `href` - if its already using the data attribute, we could be in something like an undo - where we don't need to do this
				if( (new_href=="") && (orig_href!="") )
				{
					editor.dom.setAttrib(fasc_button, 'data-fasc-href', orig_href);
					editor.dom.setAttrib(fasc_buttons, 'href', '' );
				}
				/*console.log("--------------");
				console.log("adding html");
				console.log("orig_href: "+orig_href);
				console.log("new_href: "+new_href);
				console.log("--------------");*/
				
				//now move it to data
				//editor.dom.setAttrib(fasc_button, 'data-fasc-href', orig_href);
				//editor.dom.setAttrib(fasc_buttons, 'href', '' );
			}
			//remove href to stop WordPress adding its own (embed) controls
			/*$fasc_buttons.each(function(){
				
				var $this = editor.$(this);
				var href = $this.attr("href");
				$this.attr('data-fasc-href', href);
				$this.attr('href', null);
				
			});*/
			//console.log("finished setttting content heeere");
		}
		
		

		/*function convertElement( $element, type) {
			
			var dom = editor.dom;
			
			var newNode = dom.create( type );
			
			var $newNode = $(newNode);
			
			$newNode.html($element.html());
			
			var attributes = $element.prop("attributes");
			
			$.each(attributes, function() {
				$newNode.attr(this.name, this.value);
			});
			
			return $newNode;
			
			
			//if ( before ) {
			//	view.parentNode.insertBefore( padNode, view );
			//} else {
			//	dom.insertAfter( padNode, view );
			//}
			
		}*/
		
		
		function popupwindow(editor, node, is_editing, onsubmit_callback, text_selection)
		{
			
			/*		console.log("THE EDITED");
					
			console.log(editor.selection.getContent({format : 'text'}));
			console.log(editor.selection.getNode());
			
			*/
			if(typeof text_selection == 'undefined'){
				var text_selection = "";
			}
			
			var values = [];
			if(typeof onsubmit_callback != 'function'){
				onsubmit_callback = function( button_html, button_id ) {
					
					
					console.log("onsubmit_callback: ");
					console.log("button_html: "+button_html);
					console.log("button_id: "+button_id);
					//console.log(button_html);
					//alert(button_html);
					
					/*$(node).replaceWith(button_html);
					//selected = null;
					//selected = node;
					editor.nodeChanged();
					selected = node;
					//deselectFascButton();*/
					
					var $node = editor.$(button_html);
					//jQuery( node ).data( 'rendered', false );
					
					/*editor.selection.select(node);
					var range = editor.selection.getRng();
					range.insertNode($node[0]);
					editor.dom.remove(node);*/
					
					if(is_editing)
					{
						//editor.dom.replace(node, editor.$(button_html));
						editor.$( node ).replaceWith( $node );

					}
					else
					{
						editor.selection.setContent(button_html);
						
					}
					
					var $current_button = editor.$( "[data-fasc-id='"+button_id+"']" );
					//editor.selection.select(editor.dom.select("a[data-fasc-id='"+button_id+"']")[0]);
					
					deselectFascButton();
					editor.focus(); 
					editor.nodeChanged();
					selectFascButton(editor.dom.select("a[data-fasc-id='"+button_id+"']")[0]);
					
					
					
				
					//handleEnter( view );
					//editor.$( node ).replaceWith( $node );
					//editor.dom.insertAfter( node, $node );
					//editor.dom.remove(node);
					//editor.focus();
					//editor.execCommand('mceInsertContent', false, $node);
					
					
					//editor.undoManager.add($node[0]);
					/*editor.nodeChanged();
					editor.focus();
					editor.undoManager.add($node[0]);
					selected = $node[0];*/
					
					//editor.dom.setAttrib( node, 'data-wpview-text', encodeURIComponent( text ) );
					//wp.mce.views.createInstance( type, text, match.options, force ).render();
					//selected = null;
					//editor.focus();
					//selected = node;
					//editor.focus();
					
					//editor.dom.setAttrib( node, 'data-wpview-text', encodeURIComponent( "sdfsdf" ) );
					//editor.dom.selection.select(node);
					
					//editor.nodeChanged();
					//if ( selected ) {
						//editor.wp.setViewCursor( false, $viewNode[0] );
					//}
					
				};
			}
			
			//editor.undoManager.transact( function() {
			
				wp.mce.fascpopup.open( node, 'button', onsubmit_callback, is_editing, text_selection );
			
			//});
			//wp.mce.fascpopup.open();
			
			/*$("#TB_window").remove();
			$("body").append("<div id='TB_window'></div>");
			tb_show("", "#TB_inline?height=280&width=120&inlineId=my-content-id", "");*/
			
			
		}
		
		// Keep for back-compat.
		return;
		
	});

})();
